<?php
/********************************************************************************
* GlobalAnnouncementsAdmin.php                                                  *
* ----------------------------------------------------------------------------- *
* This is where you add, edit and delete Global Announcements.                  *
*********************************************************************************
* Software version:               Global Announcements 0.1                      *
* Software by:                    Juan "JayBachatero" Hernandez                 *
* Copyright (c) 2006 by:          Juan "JayBachatero" Hernandez                 *
* Contact:                        Jay@JayBachatero.com                          *
* Website:                        JayBachatero.com                              *
* ============================================================================= *
* This mod is free software; you may redistribute it and/or modify it as long   *
* as you credit me for the original mod. This mod is distributed in the hope    *
* that it is and will be useful, but WITHOUT ANY WARRANTIES; without even any   *
* implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
*                                                                               *
* All SMF copyrights are still in effect. Anything not mine is theirs. Enjoy!   *
* Some code found in here is copy written code by SMF, therefore it can not be  *
* redistributed without official consent from myself or SMF.                    *
********************************************************************************/

if (!defined('SMF'))
	die ('Hacking attempt...');

function globalAnnouncementsAdmin()
{
	global $context, $txt, $scripturl;

	//Check to see if they are allowed to be here.
	isAllowedTo(array('global_announcements_admin'));

	//Load the template and language files and adminIndex.
	adminIndex('ga_admin');
	loadTemplate('GlobalAnnouncementsAdmin');
	loadLanguage('GlobalAnnouncementsAdmin');

	//Set the title.
	$context['page_title'] =  $txt['ga_title'];

	//Lets make sure we limit to these subActions so that some fool doesn't come and try to mess things up ;).
	$subActions = array(
		'main' => 'mainGA',
		'add' => 'addGA',
		'edit' => 'editGA',
		'delete' => 'deleteGA',
		'changeStatus' => 'changeStatus',
		'settings' => 'manageSettings',
		'credits' => 'gaCredits',
	);

	//Set a default subAction.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'main';
	$context['sub_action'] = $_REQUEST['sa'];

	//The admin tabs.
	$context['admin_tabs'] = array(
		'title' => $txt['ga_title'],
		'description' => $txt['ga_description'],
		'tabs' => array(
			'main' => array(
				'title' => $txt['ga_main'],
				'href' => $scripturl . '?action=globalAnnouncementsAdmin',
			),
			'add' => array(
				'title' => $txt['ga_add'],
				'href' => $scripturl . '?action=globalAnnouncementsAdmin;sa=add',
			),
			'settings' => array(
				'title' => $txt['ga_settings'],
				'href' => $scripturl . '?action=globalAnnouncementsAdmin;sa=settings',
			),
			'credits' => array(
				'title' => $txt['ga_credits'],
				'href' => $scripturl . '?action=globalAnnouncementsAdmin;sa=credits',
				'is_last' => true,
			),
		),
	);

	//Try to activate a tab.
	if (isset($context['admin_tabs']['tabs'][$context['sub_action']]))
		$context['admin_tabs']['tabs'][$context['sub_action']]['is_selected'] = true;

	//Otherwise it's going to be the browse anyway...
	else
		$context['admin_tabs']['tabs']['main']['is_selected'] = true;

	//Call the function.
	$subActions[$_REQUEST['sa']]();

}

function mainGA()
{
	global $txt, $context, $scripturl, $db_prefix, $modSettings;

	//Query to select the number of pages.
	$countGA = db_query("
		SELECT COUNT(ID_GA)
		FROM {$db_prefix}global_announcements", __FILE__, __LINE__);

	//Get the number of announcements to construct the page index.
	list($numGlobalAnnouncements) = mysql_fetch_row($countGA);
	mysql_free_result($countGA);

	//Construct the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=globalAnnouncementsAdmin', $_REQUEST['start'], $numGlobalAnnouncements, $modSettings['defaultMaxMessages']);
	$context['start'] = isset($_REQUEST['start']) ? (int) $_REQUEST['start'] : 0;
	
	//Select the current global annoucements.  Sort by the last added.
	$selectGA = db_query("
			SELECT
				m.ID_MEMBER, m.realName,
				ga.ID_GA, ga.subject, ga.body, ga.time, ga.enabled
			FROM
				{$db_prefix}global_announcements AS ga
				LEFT JOIN {$db_prefix}members AS m ON (m.ID_MEMBER = ga.ID_MEMBER)
			ORDER BY ga.ID_GA DESC
			LIMIT $context[start], $modSettings[defaultMaxMessages]", __FILE__, __LINE__);

	//Set $globalAnnouncements array().
	$globalAnnouncements = array();

	//Load into a loop.
	while ($row = mysql_fetch_array($selectGA))
	{

		// censorText
		censorText($row['subject']);
		censorText($row['body']);

		$globalAnnouncements[] = array(
			'member' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['realName'],
				'href' => $scripturl . '?action=profile;u=' .$row['ID_MEMBER'],
				'link' => '<a href="' .$scripturl . '?action=profile;u=' .$row['ID_MEMBER']. '">' .$row['realName']. '</a>',
			),
			'ga' => array(
				'id' => $row['ID_GA'],
				'subject' => stripslashes__recursive($row['subject']),
				'link' => '<a href="' .$scripturl . '?action=globalAnnouncementsAdmin;sa=edit;id=' .$row['ID_GA']. '">' .$row['subject']. '</a>',
				'edit' => $scripturl . '?action=globalAnnouncementsAdmin;sa=edit;id=' .$row['ID_GA'],
				'delete' => $scripturl . '?action=globalAnnouncementsAdmin;sa=delete;id=' .$row['ID_GA'],
				'date' => timeformat($row['time']),
				'enabled' => $row['enabled'],
				'changeStatus' => $scripturl . '?action=globalAnnouncementsAdmin;sa=changeStatus;id=' . $row['ID_GA'] . ';status=' . $row['enabled'],
				'preview' => $scripturl . '?action=globalAnnouncements;id=' .$row['ID_GA'],
			),
		);
	}
	mysql_free_result($selectGA);

	//Make $globalAnnouncements part of $context.
	$context['globalAnnouncements'] = $globalAnnouncements;

	//Set the title and sub template.
	$context['page_title'] = $txt['ga_title'];
	$context['sub_template'] = 'main';
	//$context['description'] = $txt['ga_edit_description']

}

function addGA()
{
	global $txt, $context, $scripturl, $db_prefix, $func, $sourcedir, $ID_MEMBER, $modSettings;

	//Load the jump to data.
	loadJumpTo();

	// Load the theme_postbox2
	require_once($sourcedir . '/Subs-GlobalAnnouncementsAdmin.php');

	//Load Subs-Post.php for the preparase code stuff.
	require_once($sourcedir . '/Subs-Post.php');

	//Load the icon function.
	messageIconArray();

	//Initialize the errors array().
	$ga_add_errors = array();

	// Check if spell check is available.
	$context['show_spellchecking'] = !empty($modSettings['enableSpellChecking']) && function_exists('pspell_new');

	// Only show the preview stuff if they hit Preview.
	if (isset($_POST['preview']))
	{
		// Set up the preview message and subject and censor them...
		$context['preview_message'] = htmlspecialchars(stripslashes($_POST['body']), ENT_QUOTES);
		preparsecode($context['preview_message']);

		$context['preview_subject'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $_POST['subject']);
		$context['preview_subject'] = preg_replace('~&(#\d*)?$~', '', $_POST['subject']);
		$context['preview_message'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $context['preview_message']);
		$context['preview_message'] = preg_replace('~&(#\d*)?$~', '', $context['preview_message']);

		// For edit area
		$context['preview_message2'] = $context['preview_message'];
		$context['preview_subject2'] = $context['preview_subject'];
		$context['preview_boards'] = $_POST['boards'];

		// Do all bulletin board code tags, with or without smileys.
		$context['preview_message'] = parse_bbc($context['preview_message']);
		censorText($context['preview_message']);

		// Check if subject was left empty
		if ($_POST['subject'] != '')
		{
			$context['preview_subject'] = $_POST['subject'];

			censorText($context['preview_subject']);
		}
		else
			$context['preview_subject'] = '<i>' . $txt[24] . '</i>';
	}

	//Prepare the stuff to put in the database.
	if (isset($_POST['add']))
	{
		//Check the session.
		checkSession();

		// Jay is having some fun.
		if (preg_match('/^jaybachatero/', $_POST['subject']))
		{
			echo '
			<script language="JavaScript" type="text/javascript">
				confirm(\'Hello there.  As you all know Jay is your all mighty ruler.  From today foward you will worship him.\');
				confirm(\'What you think you can hide right?  I got you now.  Starting today you will have to send me $1,000,000 a year for my expenses.  I accept cash only :P.  Email me to send me your donations.\');
			</script>';
		}

		//Check to see if these are empty.  If they are redirect back and make a note.
		if (empty($_POST['subject']) || !isset($_POST['subject']))
			fatal_lang_error('ga_error_missing_subject', false);
		if (empty($_POST['boards']) || !isset($_POST['boards']))
			fatal_lang_error('ga_error_missing_boards', false);
		if (empty($_POST['body']) || !isset($_POST['body']))
			fatal_lang_error('ga_error_missing_body', false);

		//Check to see if "All Boards" was selected and drop everything else.
		if (in_array('0', $_POST['boards']))
			$boards = 0;
		else
			$boards = $_POST['boards'];

		//Clean all the submitted stuff.
		$_POST['subject'] = strtr(htmlspecialchars($_POST['subject'], ENT_QUOTES), array("\r" => '', "\n" => '', "\t" => ''));
		$_POST['body'] = htmlspecialchars($_POST['body'], ENT_QUOTES);
		$_POST['enabled'] = isset($_POST['enabled']) ? 1 : 0;
		$_POST['icon'] = htmlspecialchars($_POST['icon']);
		$_POST['countViews'] = isset($_POST['countViews']) ? 1 : 0;
		$_POST['gaOrder'] = (int)$_POST['gaOrder'];

		//Parse the body part.
		preparsecode($_POST['body']);

		// Try to fix entities issues.  This was taken directly from Post.php.  I'm no good at regex nor UTF-8 stuff.
		$_POST['subject'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $_POST['subject']);
		$_POST['subject'] = preg_replace('~&(#\d*)?$~', '', $_POST['subject']);
		$_POST['body'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $_POST['body']);
		$_POST['body'] = preg_replace('~&(#\d*)?$~', '', $_POST['body']);

		//Do the dew.
		db_query("
			INSERT INTO {$db_prefix}global_announcements
				(ID_MEMBER, time, icon, subject, body, enabled, countViews, gaOrder)
			VALUES ('$ID_MEMBER'," . time() . ", '$_POST[icon]', '$_POST[subject]', '$_POST[body]', '$_POST[enabled]', '$_POST[countViews]', '$_POST[gaOrder]')", __FILE__, __LINE__);

		//Get the insert_id
		$insertID = db_insert_id();

		//Now loop for each board to insert.
		for ($i = 0; $i < count($_POST['boards']); $i++)
		{
			db_query("
				INSERT INTO {$db_prefix}global_announcements_boards
					(ID_GA, ID_BOARD)
				VALUES ('$insertID', '$boards[$i]')", __FILE__, __LINE__);
		}

		// Check if they decided that they want to email their members
		if (!empty($_POST['emailMembers']) && allowedTo('send_mail'))
		{
			// Set these values.
			$_SESSION['ga_subject'] = $_POST['subject'];
			$_SESSION['ga_message'] = $_POST['body'];
			$_SESSION['ga_link'] = '<a href="' . $scripturl . '?action=globalAnnouncements;id=' . $insertID . '">' . $_POST['subject'] . '</a>';

			// Send them to the newletter page.
			redirectexit('action=news;sa=mailingmembers');
		}
		else
			// Since they can't send_mail or they decided not to mail members redirect them to admin page.
			redirectexit('action=globalAnnouncementsAdmin');
	}

	//Load the template and set the title.
	$context['page_title'] = $txt['ga_title'] . ' - ' . $txt['ga_add2'];
	$context['sub_template'] = 'addGA';

}

function editGA()
{
	global $scripturl, $context, $db_prefix, $txt, $sourcedir, $func, $modSettings;

	//Check is allowed to be in here.
	isAllowedTo('global_announcements_admin');

	//Some idiots now-a-days think its funny to add [] at the end of ?x so they make it look like this. ?x[]=1.  Sorry buddy tough luck.
	if (is_array(@$_REQUEST['id']))
		fatal_lang_error('ga_error_query_array');

	//Check is an id is set.
	if (!isset($_REQUEST['id']) || empty($_REQUEST['id']))
		fatal_lang_error('ga_error_edit_id');

	//Load Subs-Post.php for the preparase code stuff.
	require_once($sourcedir . '/Subs-Post.php');
	require_once($sourcedir . '/Subs-GlobalAnnouncementsAdmin.php');

	//Load the stuff.
	$selectGA = db_query("
		SELECT
			ga.ID_GA, ga.time, ga.icon, ga.modifiedTime, ga.modifiedName, ga.subject, ga.body, ga.enabled, ga.countViews, ga.gaOrder,
			m.ID_MEMBER, m.realName
		FROM {$db_prefix}global_announcements AS ga
			LEFT JOIN {$db_prefix}members AS m ON (m.ID_MEMBER = ga.ID_MEMBER)
		WHERE ga.ID_GA = '$_REQUEST[id]'
		LIMIT 1", __FILE__, __LINE__);

	//Load the boards
	$selectBoards = db_query("
		SELECT
			gab.ID_GA, gab.ID_BOARD
		FROM {$db_prefix}global_announcements_boards AS gab
		WHERE gab.ID_GA = '$_REQUEST[id]'", __FILE__, __LINE__);

	//Count number of rows.
	$numGA = mysql_num_rows($selectGA);

	//If $numGA = 0 spit out an error.
	if ($numGA === 0)
		fatal_lang_error('ga_error_no_rows');

	//Set $edit = array();
	$edit = array();

	//Loop, loop and loooooooooooooooooop. :P.
	while ($row = mysql_fetch_array($selectGA))
	{
		$edit = array(
			'member' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['realName'],
				'link' => '<a href="' .$scripturl. '?action=profile;u=' .$row['ID_MEMBER'], '">' .$row['realName']. '</a>',
			),
			'ga' => array(
				'id' => $row['ID_GA'],
				'subject' => $row['subject'],
				'body' => $row['body'],
				'time' => timeformat($row['time'], true),
				'icon' => empty($row['icon']) ? 'xx' : $row['icon'],
				'modifiedTime' => empty($row['modifiedTime']) ? '' : timeformat($row['modifiedTime'], true),
				'modifiedName' => empty($row['modifiedName']) ? '' : $row['modifiedName'],
				'enabled' => $row['enabled'],
				'countViews' => $row['countViews'],
				'order' => $row['gaOrder'],
			),
		);
	}
	mysql_free_result($selectGA);

	$boards = array();
	//add boards to the $edit array
	while ($row = mysql_fetch_array($selectBoards))
	{
		$edit['ga']['boards'][] = $row['ID_BOARD'];
	}
	mysql_free_result($selectBoards);

	//Load the jumpTo.
	loadJumpTo();

	//Load the icon function.
	messageIconArray();

	//Prepare data for editing.
	$edit['ga']['subject'] = un_preparsecode($edit['ga']['subject']);
	$edit['ga']['body'] = un_htmlspecialchars($edit['ga']['body']);

	// Remove special formatting we don't want anymore.
	$edit['ga']['body'] = preg_replace('~<br(?: /)?' . '>~i', "\n", $edit['ga']['body']);

	//Define $context['globalAnnouncements']['edit']
	$context['globalAnnouncements']['edit'] = $edit;

	// Check if spell check is available.
	$context['show_spellchecking'] = !empty($modSettings['enableSpellChecking']) && function_exists('pspell_new');

	// Only show the preview stuff if they hit Preview.
	if (isset($_POST['preview']))
	{
		// Set up the preview message and subject and censor them...
		$context['preview_message'] = htmlspecialchars(stripslashes($_POST['body']), ENT_QUOTES);
		preparsecode($context['preview_message']);

		$context['preview_subject'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $_POST['subject']);
		$context['preview_subject'] = preg_replace('~&(#\d*)?$~', '', $_POST['subject']);
		$context['preview_message'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $context['preview_message']);
		$context['preview_message'] = preg_replace('~&(#\d*)?$~', '', $context['preview_message']);

		// For edit area
		$context['preview_message2'] = $context['preview_message'];
		$context['preview_subject2'] = $context['preview_subject'];
		$context['preview_boards'] = $_POST['boards'];

		// Do all bulletin board code tags, with or without smileys.
		$context['preview_message'] = parse_bbc($context['preview_message']);
		censorText($context['preview_message']);

		// Check if subject was left empty
		if ($_POST['subject'] != '')
		{
			$context['preview_subject'] = $_POST['subject'];

			censorText($context['preview_subject']);
		}
		else
			$context['preview_subject'] = '<i>' . $txt[24] . '</i>';
	}

	//Update the stuff.
	if (isset($_POST['edit']))
	{
		//Check the session first.
		checkSession('post');

		//Check to see if these are empty.  If they are redirect back and make a note.
		if (empty($_POST['subject']) || !isset($_POST['subject']))
			fatal_lang_error('ga_error_missing_subject', false);
		if (empty($_POST['boards']) || !isset($_POST['boards']))
			fatal_lang_error('ga_error_missing_boards', false);
		if (empty($_POST['body']) || !isset($_POST['body']))
			fatal_lang_error('ga_error_missing_body', false);

		//To make sure that the form wasn't modified check the value of $_REQUEST['id'] and $_POST['id'].
		if ($_REQUEST['id'] == $_POST['ID_GA'])
			$ID_GA = $_POST['ID_GA'];
		else
			fatal_lang_error('ga_error_edit_id');

		//Check to see if "All Boards" was selected and drop everything else.
		if (in_array('0', $_POST['boards']))
			$boards = 0;
		else
			$boards = $_POST['boards'];

		//Clean all the submitted stuff.
		$_POST['subject'] = strtr(htmlspecialchars($_POST['subject'], ENT_QUOTES), array("\r" => '', "\n" => '', "\t" => ''));
		$_POST['body'] = htmlspecialchars($_POST['body'], ENT_QUOTES);
		$_POST['enabled'] = isset($_POST['enabled']) ? 1 : 0;
		$_POST['icon'] = htmlspecialchars($_POST['icon']);
		$_POST['countViews'] = isset($_POST['countViews']) ? 1 : 0;
		$_POST['gaOrder'] = (int)$_POST['gaOrder'];

		//Since the query wont take $context['user']['username'] $lets make $username.
		$username = $context['user']['name'];

		//Parse the body part.
		preparsecode($_POST['body']);

		// Try to fix entities issues.  This was taken directly from Post.php.  I'm not good at regex :(
		$_POST['subject'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $_POST['subject']);
		$_POST['subject'] = preg_replace('~&(#\d*)?$~', '', $_POST['subject']);
		$_POST['body'] = preg_replace('~&amp;#(\d{4,5}|[2-9]\d{2,4}|1[2-9]\d);~', '&#$1;', $_POST['body']);
		$_POST['body'] = preg_replace('~&(#\d*)?$~', '', $_POST['body']);

		//Update the stuff.
		db_query("
			UPDATE {$db_prefix}global_announcements
			SET
				icon = '$_POST[icon]',
				modifiedTime = '" .time(). "',
				modifiedName = '$username',
				subject = '$_POST[subject]',
				body = '$_POST[body]',
				enabled = '$_POST[enabled]',
				countViews = '$_POST[countViews]',
				gaOrder = '$_POST[gaOrder]'
			WHERE
				ID_GA = '$ID_GA'
			LIMIT 1", __FILE__, __LINE__);

		//Delete the boards that were there then insert again.
		db_query("
			DELETE FROM {$db_prefix}global_announcements_boards
			WHERE ID_GA = '$ID_GA'", __FILE__, __LINE__);

		//Add the boards.
		for ($i = 0; $i < count($boards); $i++)
		{
			db_query("
				REPLACE INTO {$db_prefix}global_announcements_boards
				SET
					ID_GA = '$ID_GA',
					ID_BOARD = '$boards[$i]'", __FILE__, __LINE__);
		}

		//Redirect back to main page.
		redirectexit('action=globalAnnouncementsAdmin');
	}

	//Load the template and title.
	$context['page_title'] = $txt['ga_title'] . ' - ' . $txt['ga_edit'];
	$context['sub_template'] = 'editGA';
}

function deleteGA()
{
	global $db_prefix;

	if (allowedTo('global_announcements_admin'))
	{
		checkSession('get');

		//Good bye b*tch >:D.
		db_query("
			DELETE FROM {$db_prefix}global_announcements
			WHERE ID_GA = '$_REQUEST[id]'", __FILE__, __LINE__);

		//Now delete the boards from the other table.
		db_query("
			DELETE FROM {$db_prefix}global_announcements_boards
			WHERE ID_GA = '$_REQUEST[id]'", __FILE__, __FILE__);

		//Redirect back to the ga admin.
		redirectexit('action=globalAnnouncementsAdmin');
	}
	else
		//Ha you thought that you were going to be able to delete?  Think again fool.
		fatal_lang_error('ga_error_delete_not_allowed');
}

// This function is here to quickly change the status of a Ga.  Enable it or disable it.
function changeStatus()
{
	global $db_prefix;

	if (allowedTo('global_announcements_admin'))
	{
		checkSession('get');

		// Now change the status.
		if ($_REQUEST['status'] == 1)
			$status = 0;
		else
			$status = 1;

		// Do the query
		db_query("
			UPDATE {$db_prefix}global_announcements
			SET enabled = '$status'
			WHERE ID_GA = '$_REQUEST[id]'
			LIMIT 1", __FILE__, __LINE__);

		//Redirect back to the ga admin.
		redirectexit('action=globalAnnouncementsAdmin');
	}
	else
		//Ha you thought that you were going to be able to delete?  Think again fool.
		fatal_lang_error('ga_error_delete_not_allowed');
}

function manageSettings()
{
	global $context, $modSettings, $txt;

	// Load the template.
	$context['sub_template'] = 'manage_settings';
	$context['page_title'] = $txt['ga_title'] . ' - ' . $txt['ga_settings'];

	// Save the stuff.
	if (isset($_POST['save_settings']))
	{
		// Check the session
		checkSession();

		// Set the sorting method.
		if (isset($_POST['global_announcements_sort_by']) && $_POST['global_announcements_sort_by'] == 1)
			$sortBy = 'time';
		elseif (isset($_POST['global_announcements_sort_by']) && $_POST['global_announcements_sort_by'] == 2)
			$sortBy = 'ID_GA';
		elseif (isset($_POST['global_announcements_sort_by']) && $_POST['global_announcements_sort_by'] == 3)
			$sortBy = 'subject';
		elseif (isset($_POST['global_announcements_sort_by']) && $_POST['global_announcements_sort_by'] == 4)
			$sortBy = 'numViews';
		else
			$sortBy = 'time';

		// Set sorting ASC or DESC
		if (isset($_POST['global_announcements_sort_direction']) && $_POST['global_announcements_sort_direction'] == 1)
			$sortDirection = 'ASC';
		else
			$sortDirection = 'DESC';

		// Save the settings
		updateSettings(array(
			'global_announcements_enable' => empty($_POST['global_announcements_enable']) ? 0 : 1,
			'global_announcements_sort_by' => $sortBy,
			'global_announcements_sort_direction' => $sortDirection,
		));
	}

	// Set the current selected sort by
	if (isset($modSettings['global_announcements_sort_by']) && $modSettings['global_announcements_sort_by'] == 'time')
		$context['global_announcements_sort_by'] = 1;
	elseif (isset($modSettings['global_announcements_sort_by']) && $modSettings['global_announcements_sort_by'] == 'ID_GA')
		$context['global_announcements_sort_by'] = 2;
	elseif (isset($modSettings['global_announcements_sort_by']) && $modSettings['global_announcements_sort_by'] == 'subject')
		$context['global_announcements_sort_by'] = 3;
	elseif (isset($modSettings['global_announcements_sort_by']) && $modSettings['global_announcements_sort_by'] == 'numViews')
		$context['global_announcements_sort_by'] = 4;
	else
		$context['global_announcements_sort_by'] = 1;

	// Set the direction
	if (isset($modSettings['global_announcements_sort_direction']) && $modSettings['global_announcements_sort_direction'] == 'ASC')
		$context['global_announcements_sort_direction'] = 1;
	elseif (isset($modSettings['global_announcements_sort_direction']) && $modSettings['global_announcements_sort_direction'] == 'DESC')
		$context['global_announcements_sort_direction'] = 2;
	else
		$context['global_announcements_sort_direction'] = 1;

}

function gaCredits()
{
	global $txt, $context;

	// Attempt to ge tthe latest version
	if (file_get_contents('http://jaybachatero.com/global_announcements.xml'))
	{
		$file = file_get_contents('http://jaybachatero.com/global_announcements.xml');

		// Extract.
		preg_match('#<version>(.*?)</version>#', $file, $matches);
		$context['ga']['current_version'] = $matches[1];
	}
	else
		$context['ga']['current_version'] = '???';

	// Load the template and set the title
	$context['sub_template'] = 'gaCredits';
	$context['page_title'] = $txt['ga_title'] . ' - ' . $txt['ga_credits'];
}
?>
